<?PHP
/*
 * 支付宝在线支付模块
 * 2012.2.6 更新
 */


/*
	@$data 参数说明(除注明的外，其它值在pay_sent及pay_respond均可用)
	$data=Array();
	$data['api_id'] ='在线支付账号ID';	 #从数据库中读取[在线支付账号ID]
	$data['api_key']='在线支付接口密钥';   #从数据库中读取[在线支付接口密钥](加密后保存)

	$data['account']='签约支付宝账号或卖家支付宝帐户'; #从数据库中读取的[开户账号]，部分在线支付不需要此值
	$data['receive']='交易过程中服务器通知的页面';	 #由系统设置，不允许用户修改,仅在pay_sent有值
	$data['siteurl']='网站URL';		#从数据库中读取胜,仅在pay_sent有值
	$data['usermail']='用户邮箱地址';  #从数据库中读取

	$data['fund']  ='支付金额';		#支付时使用,仅在pay_sent有值

	$data['payid'] ='支付流水号';
	$data['payfund']='数据库中的金额'; #接收响应时使用,仅在pay_respond有值
	$data['paytype']='支付方式编号';
	$data['result'] ='响应时的备注';   #在接收响应时可将备注赋予此值，将会被写入到付款确认记录的“结果反馈”中
 */


/*
 * 接口设置（根据支付方式不同可能不同）
 */
$pay_sign_type	  = "MD5";	//加密方式 不需修改
$pay_input_charset  = "UTF-8";	//字符编码格式 目前支持 GBK 或 utf-8 
$pay_transport	  = "http";	//访问模式,根据自己的服务器是否支持ssl访问，若支持请选择https；若不支持请选择http
$pay_method		 = "directPay";	//默认支付方式，四个值可选：bankPay(网银); cartoon(卡通); directPay(余额); CASH(网点支付


/*
 * 提交用户支付请求
 * 流程：处理用户提交数据，并转向到第三方支付平台。转向后供用户操作将在第三方平台执行
 * @return ：正常时直接转向到第三方平台并结束程序（如exit或die），不用返回。若有错误，请返回错误信息，由支付主程序显示错误信息
 */
function pay_sent(&$data)
{
	global $pay_sign_type,$pay_input_charset,$pay_transport,$pay_method;
	$parameter = array(
		"service"	 => "create_direct_pay_by_user",
		"payment_type"=>"1",				  // 商品支付类型 1 ＝商品购买 2＝服务购买 3＝网络拍卖 4＝捐赠 5＝邮费补偿 6＝奖金

		"partner"	 =>$data['api_id'],			 //合作商户号
		//"agent"=> $agent,//合作厂商ID
		"seller_email" => $data['account'],   //卖家邮箱，必填
		//"return_url" =>"",  //同步返回，
		"notify_url"  =>$data['receive'],  //返回地址
		"show_url"	=> $data['siteurl'],   //商品相关网站公司
		"_input_charset" => $pay_input_charset, //字符集，默认为GBK

		"subject"	 => "在线预付款",	 //商品名称，必填
		"out_trade_no"=> $data['payid'] ,	//支付流水号，必填。 此值在用户支付时生成，不允许修改
		"total_fee"   => $data['fund'],	//商品单价，必填

		"paymethod"   => $pay_method,
		"defaultbank" => "",

		"buyer_email" => $data['usermail'] //如果不需要此项，可屏蔽或删除此行
	);

	$alipay = new alipay_service($parameter,$data['api_key'],$pay_sign_type);
	$link=$alipay->create_url();
	header('location: '.$link); //转到支付宝的支付平台
	exit;
}

/*
 * 读取交易ID
 */
function pay_getid()
{
	return trim($_REQUEST['out_trade_no']);
}

/*
 * 处理第三方平台的确认请求，确认后自动入账
 * 流程：根据支付平台请求数据判断是否为合法请求。若支付平台需要反回数据，请在本函数中输出。
 * @return ：正确时返回Y，错误时返回错误信息。支付主程序在调用本函数后不作任何显示（输出）操作
 */
function pay_respond(&$data)
{
	global $pay_sign_type,$pay_input_charset,$pay_transport;
	$alipay = new alipay_notify($data['api_id'],$data['api_key'],$pay_sign_type,$pay_input_charset,$pay_transport);
	$verify_result = $alipay->notify_verify();
	if($verify_result) {
		echo "success"; //支付宝系统需要
		$data['result']=$_REQUEST['trade_no'];
		$v_oid	=trim($_REQUEST['out_trade_no']);
		$pay_fund =doubleval($_REQUEST['total_fee']);

		//检查金额及支付流水号是否一致，如果一致才返回Y
		//系统接收到Y会自动为会员入款，接收不到Y则不入款
		if ($data['payfund']==$pay_fund and $data['payid']==$v_oid)
		{
			return 'Y';
		}
		return "error";
	}
	else
	{
		echo "fail";//支付宝系统需要
		return "error!";
	}
}


// 日志消息,把支付宝返回的参数记录下来
/* log_result 在下面的函数中会用到，不要更改名称 */
function  log_result($word) {
	pay_log_mysql($word);
}

/*
 ***************************************************************
 *  以上代码为用户代码，可根据情况修改
 ***************************************************************
 */

/*
 ***************************************************************
 *  以下代码为支付宝代码，不要修改
 ***************************************************************
 */



/**生成签名结果
 *$array要加密的数组
 *return 签名结果字符串
*/
function build_mysign($sort_array,$security_code,$sign_type = "MD5") {
	$prestr = create_linkstring($sort_array);	 	//把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
	$prestr = $prestr.$security_code;				//把拼接后的字符串再与安全校验码直接连接起来
	if($sign_type == 'MD5') {
		$mysign = md5($prestr);
	}elseif($sign_type =='DSA') {
		//DSA 签名方法待后续开发
		die("DSA 签名方法待后续开发，请先使用MD5签名方式");
	}else {
		die("支付宝暂不支持".$sign_type."类型的签名方式");
	}
	return $mysign;
}


/********************************************************************************/

/**把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
	*$array 需要拼接的数组
	*return 拼接完成以后的字符串
*/
function create_linkstring($array) {
	$arg  = "";
	while (list ($key, $val) = each ($array)) {
		$arg.=$key."=".$val."&";
	}
	$arg = substr($arg,0,count($arg)-2);			 //去掉最后一个&字符
	return $arg;
}

/********************************************************************************/


/**把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
 **使用场景：GET方式请求时，对URL的中文进行编码
	*$array 需要拼接的数组
	*return 拼接完成以后的字符串
*/
function create_linkstring_urlencode($array) {
	$arg  = "";
	while (list ($key, $val) = each ($array)) {
		if ($key != "service" && $key != "_input_charset")
			$arg.=$key."=".urlencode($val)."&";
		else $arg.=$key."=".$val."&";
	}
	$arg = substr($arg,0,count($arg)-2);			 //去掉最后一个&字符
	return $arg;
}

/********************************************************************************/

/**除去数组中的空值和签名参数
	*$parameter 加密参数组
	*return 去掉空值与签名参数后的新加密参数组
 */
function para_filter($parameter) {
	$para = array();
	while (list ($key, $val) = each ($parameter)) {
		if($key == "sign" || $key == "sign_type" || $val == "")continue;
		else	$para[$key] = $parameter[$key];
	}
	return $para;
}

/********************************************************************************/

/**对数组排序
	*$array 排序前的数组
	*return 排序后的数组
 */
function arg_sort($array) {
	ksort($array);
	reset($array);
	return $array;
}




/********************************************************************************/



class alipay_service {

	var $gateway;       //网关地址
	var $security_code; //安全校验码
	var $mysign;        //加密结果（签名结果）
	var $sign_type;     //加密类型
	var $parameter;     //需要加密的参数数组
	var $_input_charset;//字符编码格式

	/**构造函数
	*从配置文件及入口文件中初始化变量
	*$parameter 需要加密的参数数组
	*$security_code 安全校验码
	*$sign_type 加密类型
	*/
	function alipay_service($parameter,$security_code,$sign_type) {
		$this->gateway        = "https://mapi.alipay.com/gateway.do?";
		$this->security_code  = $security_code;
		$this->sign_type      = $sign_type;
		$this->parameter      = para_filter($parameter);

		//设定_input_charset的值,为空值的情况下默认为GBK
		if($parameter['_input_charset'] == '')
			$this->parameter['_input_charset'] = 'GBK';

		$this->_input_charset   = $this->parameter['_input_charset'];

		//获得签名结果
		$sort_array   = arg_sort($this->parameter);	//得到从字母a到z排序后的加密参数数组
		$this->mysign = build_mysign($sort_array,$this->security_code,$this->sign_type);
	}

	/********************************************************************************/

	/**构造请求URL（GET方式请求）
	*return 请求url
	 */
	function create_url() {
		$url         = $this->gateway;
		$sort_array  = array();
		$sort_array  = arg_sort($this->parameter);
		$arg         = create_linkstring_urlencode($sort_array);	//把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
		
		//把网关地址、已经拼接好的参数数组字符串、签名结果、签名类型，拼接成最终完整请求url
		$url.= $arg."&sign=" .$this->mysign ."&sign_type=".$this->sign_type;
		return $url;
	}

	/********************************************************************************/

	/**构造Post表单提交HTML（POST方式请求）
	*return 表单提交HTML文本
	 */
	function build_postform() {

		$sHtml = "<form id='alipaysubmit' name='alipaysubmit' action='".$this->gateway."_input_charset=".$this->parameter['_input_charset']."' method='post'>";

		while (list ($key, $val) = each ($this->parameter)) {
			$sHtml.= "<input type='hidden' name='".$key."' value='".$val."'/>";
		}

		$sHtml = $sHtml."<input type='hidden' name='sign' value='".$this->mysign."'/>";
		$sHtml = $sHtml."<input type='hidden' name='sign_type' value='".$this->sign_type."'/></form>";

		$sHtml = $sHtml."<input type='button' name='v_action' value='支付宝确认付款' onClick='document.forms[\"alipaysubmit\"].submit();'>";
		return $sHtml;
	}
	/********************************************************************************/

}


class alipay_notify {
	var $gateway;        //网关地址
	var $security_code;  //安全校验码
	var $partner;        //合作伙伴ID
	var $sign_type;      //加密方式 系统默认
	var $mysign;         //加密结果（签名结果）
	var $_input_charset; //字符编码格式
	var $transport;      //访问模式

	/**构造函数
	*从配置文件中初始化变量
	*$partner 合作身份者ID
	*$security_code 安全校验码
	*$sign_type 加密类型
	*$_input_charset 字符编码格式
	*$transport 访问模式
	 */
	function alipay_notify($partner,$security_code,$sign_type,$_input_charset = "GBK",$transport= "https") {

		$this->transport = $transport;
		if($this->transport == "https") {
			$this->gateway = "https://mapi.alipay.com/trade/notify_query.do?";
		}else {
			$this->gateway = "http://notify.alipay.com/trade/notify_query.do?";
		}
		$this->partner          = $partner;
		$this->security_code    = $security_code;
		$this->mysign           = "";
		$this->sign_type        = $sign_type;
		$this->_input_charset   = $_input_charset;
	}

	/********************************************************************************/

	/**对notify_url的认证
	*返回的验证结果：true/false
	 */
	function notify_verify() {
		//获取远程服务器ATN结果，验证是否是支付宝服务器发来的请求
		if($this->transport == "https") {
			$veryfy_url = $this->gateway. "service=notify_verify" ."&partner=" .$this->partner. "&notify_id=".$_POST["notify_id"];
		} else {
			$veryfy_url = $this->gateway. "partner=".$this->partner."&notify_id=".$_POST["notify_id"];
		}
		$veryfy_result = $this->get_verify($veryfy_url);

		//生成签名结果
		if(empty($_POST)) { //判断POST来的数组是否为空
			return false;
		}
		else {
			$post          = para_filter($_POST); //对所有POST返回的参数去空
			$sort_post     = arg_sort($post); //对所有POST反馈回来的数据排序
			$this->mysign  = build_mysign($sort_post,$this->security_code,$this->sign_type);   //生成签名结果
	
			//写日志记录
			log_result("notify_verify_result=".$veryfy_result."\n veryfy_url=$veryfy_url \n notify_url_log:sign=".$_POST["sign"]."&mysign=".$this->mysign."\n".create_linkstring($sort_post));
	
			//判断veryfy_result是否为ture，生成的签名结果mysign与获得的签名结果sign是否一致
			//$veryfy_result的结果不是true，与服务器设置问题、合作身份者ID、notify_id一分钟失效有关
			//mysign与sign不等，与安全校验码、请求时的参数格式（如：带自定义参数等）、编码格式有关
			if (preg_match("/true$/i",$veryfy_result) && $this->mysign == $_POST["sign"]) {
				return true;
			} else {
				return false;
			}
		}
	}

	/********************************************************************************/

	/**对return_url的认证
	*return 验证结果：true/false
	 */
	function return_verify() {
		//获取远程服务器ATN结果，验证是否是支付宝服务器发来的请求
		if($this->transport == "https") {
			$veryfy_url = $this->gateway. "service=notify_verify" ."&partner=" .$this->partner. "&notify_id=".$_GET["notify_id"];
		} else {
			$veryfy_url = $this->gateway. "partner=".$this->partner."&notify_id=".$_GET["notify_id"];
		}
		$veryfy_result = $this->get_verify($veryfy_url);

		//生成签名结果
		if(empty($_GET)) {  //判断GET来的数组是否为空
			return false;
		}
		else {
			$get          = para_filter($_GET);  //对所有GET反馈回来的数据去空
			$sort_get     = arg_sort($get);    //对所有GET反馈回来的数据排序
			$this->mysign  = build_mysign($sort_get,$this->security_code,$this->sign_type);	//生成签名结果
	
			//写日志记录
			log_result("return_verify_result=".$veryfy_result."\nveryfy_url=$veryfy_url\n return_url_log:sign=".$_GET["sign"]."&mysign=".$this->mysign."\n".create_linkstring($sort_get));
	
			//判断veryfy_result是否为ture，生成的签名结果mysign与获得的签名结果sign是否一致
			//$veryfy_result的结果不是true，与服务器设置问题、合作身份者ID、notify_id一分钟失效有关
			//mysign与sign不等，与安全校验码、请求时的参数格式（如：带自定义参数等）、编码格式有关
			if (preg_match("/true$/i",$veryfy_result) && $this->mysign == $_GET["sign"]) {			
				return true;
			}else {
				return false;
			}
		}
	}

	/********************************************************************************/

	/**获取远程服务器ATN结果
	*$url 指定URL路径地址
	*return 服务器ATN结果集
	 */
	function get_verify($url,$time_out = "60") {
		$urlarr     = parse_url($url);
		$errno      = "";
		$errstr     = "";
		$transports = "";
		if($urlarr["scheme"] == "https") {
			$transports = "ssl://";
			$urlarr["port"] = "443";
		} else {
			$transports = "tcp://";
			$urlarr["port"] = "80";
		}
		$fp=@fsockopen($transports . $urlarr['host'],$urlarr['port'],$errno,$errstr,$time_out);
		if(!$fp) {
			die("ERROR: $errno - $errstr<br />\n");
		} else {
			fputs($fp, "POST ".$urlarr["path"]." HTTP/1.1\r\n");
			fputs($fp, "Host: ".$urlarr["host"]."\r\n");
			fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
			fputs($fp, "Content-length: ".strlen($urlarr["query"])."\r\n");
			fputs($fp, "Connection: close\r\n\r\n");
			fputs($fp, $urlarr["query"] . "\r\n\r\n");
			while(!feof($fp)) {
				$info[]=@fgets($fp, 1024);
			}
			fclose($fp);
			$info = implode(",",$info);
			return $info;
		}
	}

	/*****************************************/

}

if(isset($_GET['_checkFileErr']) and $_GET['_checkFileErr']=='Y'){
	echo '[Check OK]';
}
?>